#include <qlabel.h>
#include <qpainter.h>
#include <qapplication.h>
#include <qpixmap.h>
#include <qscrollbar.h>
#include <stdlib.h>
#include <math.h>
#include <stdio.h>
#include <unistd.h>

#include "sndctrl.h"


class SweepControl : public QLabel
{
Q_OBJECT
 public:
    SweepControl(QWidget * parent=NULL, const char * name=NULL);
    ~SweepControl();
 public slots:
    void phiBarChanged(int p);
    void thetaBarChanged(int t);
 signals:
    void sweepTo(double theta, double phi);
 private:
    QScrollBar * thetaBar, * phiBar;
    int theta, phi;
    bool verbose;
 protected:
    void paintEvent(QPaintEvent *);
};


class OutputPlugin : public QFrame
{
Q_OBJECT
 public:
    OutputPlugin(bool measmode, int newRate, bool verbosemode, Sound * soundApp);
    ~OutputPlugin();
 public slots:
    void newDataReady(int channels, int frameSize, signed short** data);
    void sweepTo(double theta, double phi); 
    void speechActivityChanged(bool active);
 private:
    SoundReceiver * receiver;
    int newSampleRate,oldSampleRate;
    double theta, phi;
    bool active;
    int channels;
    bool verbose,measuremode;
    int oldphi;
    bool measure;
 protected:
    void paintEvent(QPaintEvent *);
};
