// Displays the positions and names of the microphones
#include <qpainter.h>
#include <qpixmap.h>
#include <stdlib.h>
#include <math.h>

#include "showmicpos.h"

ShowMicPos::ShowMicPos(QWidget * parent=NULL, const char * name=NULL) 
    : QFrame(parent, "MicPos")
{
    setFixedSize(220,220);
    setGeometry(640,85,width(),height());
    setCaption("Microphone Positions");
    setPalette( QPalette( QColor(255, 255, 255) ) );
    show();
    repaint();
}

ShowMicPos::~ShowMicPos()
{
}

inline int abs(int a)
{
    if (a>0) {return a;}
    return -a;
}

void ShowMicPos::paintEvent(QPaintEvent *)
{
#include "../lib/micpos.h"
    int i,x,y;
    int max=0;
    char c[2];
    QPainter p;
    p.begin(this);
    // evaluate maximum values for the calculation od the scale
    for (i=0; i<MICNUM; i++) {
        if (abs(int(micpos[i].x))>max) {max=abs(int(micpos[i].x));}
        if (abs(int(micpos[i].y))>max) {max=abs(int(micpos[i].y));}
    }
    // draw coordinate axis and the arrows
    p.setPen(black);
    p.drawLine(110,110,180,110);
    p.drawLine(180,110,175,107);
    p.drawLine(180,110,175,113);
    p.drawText(166,108,"x");
    p.drawLine(110,110,110,40);
    p.drawLine(110,40,107,45);
    p.drawLine(110,40,113,45);
    p.drawText(102,55,"y");
    // draw the microphone Positions and their Names
    for (i=0; i<MICNUM; i++) {
	c[0]='A'+i;
	c[1]=0;
        x=int(micpos[i].x*100.0/max);
        y=int(micpos[i].y*100.0/max);
	p.setPen(QColor(360/MICNUM*i,255,255,QColor::Hsv));
        QBrush brush(QColor(360/MICNUM*i,255,255,QColor::Hsv));
        p.setBrush(brush);
        p.drawPie(102+x,102+y,16,16,0,5759);
        p.setPen(white);
	p.drawText(106+x,114+y,c);
    }
    // draw the scale
    p.setPen(black);
    p.drawLine(10,210,100*100/max,210);
    p.drawLine(10,208,10,212);
    p.drawLine(100*100/max,208,100*100/max,212);
    p.drawText(12,208,"100mm");
    p.end();
}
