// some useful functions...

#include "tools.h"
#include <math.h>

inline double si(double x)
{
  if (x==0.0) {return 1.0;}
  else {return sin(x)/x;}
}


void lowpass(signed short * a, int size, int sampleRate, int freq, int filterLength)
{
    int i,k,n;
    int filter[filterLength];
    signed short copy[size];
    double omega;
    if (filterLength%2==0) {filterLength-=1;}
    omega=double(freq)/double(sampleRate);
    for (i=-filterLength/2; i<=filterLength/2; i++) {
	filter[i+filterLength/2]=
	  int(32768.0*2.0*omega*si(double(i*2)*M_PI*omega));
    }
    memcpy(copy,a,size*sizeof(short));
    for (i=0; i<size; i++) {
	n=0;
	for (k=0; k<filterLength; k++) {
	    if (i-k>=0) {n+=(filter[k]*copy[i-k]);}
	}
	a[i]=n/32768;
    }
}

void correlate(signed short * a, signed short * b, int size, int shift, int * result)
{
    int i,k,r,ashift,bshift;
    for (i=-shift/2; i<shift/2; i++) {
	r=0;
	ashift=i/2+size/2;
	bshift=(-i+1)/2+size/2;
	for (k=-(size-shift)/2; k<(size-shift)/2; k++) {
	    r+=a[ashift+k]*b[bshift+k]/(size-shift);
	}
	result[i+shift/2]=r;
    }
}
